math CodeLibrary {
real version = 1.0; 
}
/*--------------- CONSTRUCT MODULAR PROGRAM CONSTRUCTOR LIBRARY
//------------------------------ ODE DOMAINS
//%START odeDomains
//% INDEPENDENT VARIABLE
realDomain t s; t.min=0; t.max=30; t.delta = 0.1;
//%END odeDomains

//------------------------------ ODE FLOW CALCULATION
//%START flowODECalc
C:t = (F/V)*(Cin-Cout);
//%END flowODECalc
//------------------------------ EXCHANGE CACULATIONS
//%START exchangeCalc
C1:t	= PS/V1*(C2-C1);
C2:t	= PS/V2*(C1-C2);
//%END exchangeCalc
//
//------------------------------ CONSUME CALCULATION
//%START consumeCalc
C:t = -(G/V)*C;
//%END consumeCalc
//
//------------------------------ REACTION A->B
//%START reactionCalc1
A:t = -G/V*A;
B:t = G/V*A;
//%END reactionCalc1
//%START pdeDomains
// INDEPENDENT VARIABLES
realDomain  t s; t.min=0; t.max=30; t.delta = 0.1;
real L = 0.1 cm;
real Ndivx = 31;
realDomain x cm ; x.min=0; x.max=L; x.ct = Ndivx;
//%END pdeDomains
//------------------------------ BOUNDARY CONDITIONS
//%START flowBC
when  (x=x.min) (-F*L/V)*(C-Cin)+D*C:x = 0;
when  (x=x.max) { C:x = 0; Cout = C;}
//%END flowBC
//%START reverseFlowBC
when  (x=x.max) (F*L/V)*(C-Cin)+D*C:x = 0;
when  (x=x.min) { C:x = 0; Cout = C;}
//%END reverseFlowBC
//%START noFlowBC
when(x=x.min)  C:x=0;
when(x=x.max)  C:x=0;
//%END noFlowBC
//------------------------------ FLOW DIFF CALCULATION
//%START           flowDiffCalc
C:t =  -(F*L/V)*C:x
       + D*C:x:x ;
//%END             flowDiffCalc

//------------------------------ DIFFUSION CALCULATION
//%START diffusionCalc
C:t = D*C:x:x ;
//%END diffusionCalc

*/
