import nsrunit; unit conversion on;
math transport1species {
realDomain t s; t.min=0; t.max=120; t.delta=.1;
// PARAMETERS
extern real A1in(t);
real Fp = 1 ml/(g*min);
real G2 = 1 ml/(g*min);
real V1 = 0.05 ml/g;
real V2 = 0.10 ml/g;
real Surf = 1 cm^2/g, Ttot = 0.005 umol/cm^2;
real SoV1=Surf/V1;
real SoV2=Surf/V2;
real KdA1 = 10 uM;	
real KdA2 = 10 uM;	
real konA1 = 20 uM^(-1)*s^(-1); 
real konA2 = 20 uM^(-1)*s^(-1); 
real kofA1 = KdA1*konA1 ;
real kofA2 = KdA2*konA2 ;
real kTA12 = 30 s^(-1);
real kTA21 = 30 s^(-1);
real kT12 = 50 sec^(-1);
real kT21 = 50 sec^(-1);

// DEPENDENT VARIABLES
real A1(t) mM; 
real A2(t) mM; 
real T1(t) umol/cm^2; 
real T2(t) umol/cm^2; 
real T1A1(t) umol/cm^2;
real T2A2(t) umol/cm^2;
// INITIAL CONDITIONS
when (t=t.min) {A1=0; T1A1=0;}
when (t=t.min) {A2=0; T2A2=0;}
when (t=t.min) T1=Ttot/2;
when (t=t.min) T2=Ttot/2;
// ORDINARY DIFFERENTIAL EQUATIONS
A1:t = Fp/V1*(A1in-A1)
     +(-konA1*A1*T1 + kofA1*T1A1)*SoV1;
A2:t = -G2/V2*A2
     +(-konA2*A2*T2 + kofA2*T2A2)*SoV2;
T1:t = -konA1*A1*T1 + kofA1*T1A1 
     - kT12*T1 + kT21*T2;
T1A1:t = konA1*A1*T1 - kofA1*T1A1
       - kTA12*T1A1 + kTA21*T2A2;
T2:t = -konA2*A2*T2 + kofA2*T2A2 
     +kT12*T1 - kT21*T2;
T2A2:t = konA2*A2*T2 - kofA2*T2A2
       +kTA12*T1A1 - kTA21*T2A2;
real TTOT(t) umol/cm^2;
TTOT = T1
     +T2
     +T1A1
     +T2A2;
}
// This MML file generated from Trans1.mpc using MPC.
